///Anagog Flutter plugin Location object. Use this inside [Micromoment] object
///[latitude] location latitude
///[longitude] location longitude
class Location {
  final double latitude;
  final double longitude;

  Location({required this.latitude, required this.longitude});
  Map<String, dynamic> toJson() =>
      {'latitude': latitude, 'longitude': longitude};

  factory Location.fromJson(Map<String, dynamic> json) =>
      Location(latitude: json['latitude'], longitude: json['longitude']);

  @override
  bool operator ==(Object other) =>
      other is Location &&
      other.runtimeType == runtimeType &&
      other.latitude == latitude &&
      other.longitude == longitude;

  @override
  int get hashCode => 31 * (latitude.hashCode + longitude.hashCode);

  @override
  String toString() => """"{ latitude: $latitude, longitude: $longitude }""";

  Location copyWith({double? latitude, double? longitude}) => Location(
      latitude: latitude ?? this.latitude,
      longitude: longitude ?? this.longitude);
}
